#ifndef LCD_IMPL_H
#define LCD_IMPL_H

/* FreeRTOS */
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

/* Device Drivers */
#include "fsl_edma.h"

typedef struct {
    SemaphoreHandle_t dma_semphr;
    edma_handle_t dma_handle;
} lcd_impl_t;

epd_ret_t epd_impl_init(void *handle);
epd_ret_t epd_impl_write_command(void *handle, uint8_t *command, uint32_t len);
epd_ret_t epd_impl_write_data(void *handle, uint8_t *data, uint32_t len);
epd_ret_t epd_impl_reset(void *handle);
epd_ret_t epd_impl_delay(void *handle, uint32_t msec);

#endif