#ifndef UI_HELPERS_H
#define UI_HELPERS_H

/* FreeRTOS */
#include "FreeRTOS.h"
#include "semphr.h"

/* LVGL */
#include "lvgl.h"

typedef enum {
    UI_STANDBY_CMD_UPDATE_TIME,
} ui_standby_queue_cmd_t;

typedef struct {
    ui_standby_queue_cmd_t cmd;
    void                  *payload;
} ui_standby_queue_t;

extern SemaphoreHandle_t g_lvgl_semphr;
extern QueueHandle_t     g_ui_standby_queue;

extern lv_font_t *g_font_noto_sans_bold_72;
extern lv_obj_t *g_screen_standby;

int ui_setup(void);

#endif