#include "ui_helpers.h"

QueueHandle_t g_ui_standby_queue;

lv_font_t *g_font_noto_sans_bold_72;
lv_obj_t  *g_screen_standby;

void ui_standby_task(void *pvParameters);

int ui_setup(void) {
    g_ui_standby_queue = xQueueCreate(2, sizeof(ui_standby_queue_t));
    if (g_ui_standby_queue == NULL) {
        return -1;
    }

    g_font_noto_sans_bold_72 = lv_font_load("A:/resources/fonts/noto-sans_bold_72.bin");
    if (g_font_noto_sans_bold_72 == NULL) {
        return -2;
    }

    g_screen_standby = lv_obj_create(NULL);
    if (g_screen_standby == NULL) {
        return -3;
    }

    lv_scr_load(g_screen_standby);

    if (xTaskCreate(ui_standby_task, "U_STBY", 256, NULL, 14, NULL) != pdPASS) {
        return -4;
    }

    return 0;
}